"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TldrawUiContextProvider_exports = {};
__export(TldrawUiContextProvider_exports, {
  TldrawUiContextProvider: () => TldrawUiContextProvider
});
module.exports = __toCommonJS(TldrawUiContextProvider_exports);
var import_jsx_runtime = require("react/jsx-runtime");
var import_assetUrls = require("../assetUrls");
var import_useTools = require("../hooks/useTools");
var import_useTranslation = require("../hooks/useTranslation/useTranslation");
var import_overrides = require("../overrides");
var import_actions = require("./actions");
var import_asset_urls = require("./asset-urls");
var import_breakpoints = require("./breakpoints");
var import_components = require("./components");
var import_dialogs = require("./dialogs");
var import_events = require("./events");
var import_toasts = require("./toasts");
function TldrawUiContextProvider({
  overrides,
  components,
  assetUrls,
  onUiEvent,
  forceMobile,
  children
}) {
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_asset_urls.AssetUrlsProvider, { assetUrls: (0, import_assetUrls.useDefaultUiAssetUrlsWithOverrides)(assetUrls), children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_useTranslation.TranslationProvider, { overrides: (0, import_overrides.useMergedTranslationOverrides)(overrides), children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_events.UiEventsProvider, { onEvent: onUiEvent, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_toasts.ToastsProvider, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_dialogs.DialogsProvider, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_breakpoints.BreakPointProvider, { forceMobile, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_components.TldrawUiComponentsProvider, { overrides: components, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(InternalProviders, { overrides, children }) }) }) }) }) }) }) });
}
function InternalProviders({
  overrides,
  children
}) {
  const mergedOverrides = (0, import_overrides.useMergedOverrides)(overrides);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_actions.ActionsProvider, { overrides: mergedOverrides.actions, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_useTools.ToolsProvider, { overrides: mergedOverrides.tools, children }) });
}
//# sourceMappingURL=TldrawUiContextProvider.js.map
