import { jsx } from "react/jsx-runtime";
import * as React from "react";
import { useDefaultColorTheme } from "../../shared/ShapeFill.mjs";
import { TextLabel } from "../../shared/TextLabel.mjs";
import { ARROW_LABEL_FONT_SIZES, TEXT_PROPS } from "../../shared/default-shape-constants.mjs";
const ArrowTextLabel = React.memo(function ArrowTextLabel2({
  id,
  text,
  size,
  font,
  position,
  width,
  isSelected,
  labelColor
}) {
  const theme = useDefaultColorTheme();
  return /* @__PURE__ */ jsx(
    TextLabel,
    {
      id,
      classNamePrefix: "tl-arrow",
      type: "arrow",
      font,
      fontSize: ARROW_LABEL_FONT_SIZES[size],
      lineHeight: TEXT_PROPS.lineHeight,
      align: "middle",
      verticalAlign: "middle",
      text,
      labelColor: theme[labelColor].solid,
      textWidth: width,
      isSelected,
      style: {
        transform: `translate(${position.x}px, ${position.y}px)`
      }
    }
  );
});
export {
  ArrowTextLabel
};
//# sourceMappingURL=ArrowTextLabel.mjs.map
