import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import * as React from "react";
import { ShapeFill, useDefaultColorTheme } from "../../shared/ShapeFill.mjs";
import { inkyCloudSvgPath } from "../cloudOutline.mjs";
const DrawStyleCloud = React.memo(function StyleCloud({
  fill,
  color,
  strokeWidth,
  w,
  h,
  id,
  size
}) {
  const theme = useDefaultColorTheme();
  const path = inkyCloudSvgPath(w, h, id, size);
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsx(ShapeFill, { theme, d: path, fill, color }),
    /* @__PURE__ */ jsx("path", { d: path, stroke: theme[color].solid, strokeWidth, fill: "none" })
  ] });
});
export {
  DrawStyleCloud
};
//# sourceMappingURL=DrawStyleCloud.mjs.map
