import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import * as React from "react";
import { ShapeFill, useDefaultColorTheme } from "../../shared/ShapeFill.mjs";
import { cloudSvgPath } from "../cloudOutline.mjs";
const SolidStyleCloud = React.memo(function SolidStyleCloud2({
  fill,
  color,
  strokeWidth,
  w,
  h,
  id,
  size
}) {
  const theme = useDefaultColorTheme();
  const path = cloudSvgPath(w, h, id, size);
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsx(ShapeFill, { theme, d: path, fill, color }),
    /* @__PURE__ */ jsx("path", { d: path, stroke: theme[color].solid, strokeWidth, fill: "none" })
  ] });
});
export {
  SolidStyleCloud
};
//# sourceMappingURL=SolidStyleCloud.mjs.map
