import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import * as React from "react";
import { ShapeFill, useDefaultColorTheme } from "../../shared/ShapeFill.mjs";
const SolidStyleEllipse = React.memo(function SolidStyleEllipse2({
  w,
  h,
  strokeWidth: sw,
  fill,
  color
}) {
  const theme = useDefaultColorTheme();
  const cx = w / 2;
  const cy = h / 2;
  const rx = Math.max(0, cx);
  const ry = Math.max(0, cy);
  const d = `M${cx - rx},${cy}a${rx},${ry},0,1,1,${rx * 2},0a${rx},${ry},0,1,1,-${rx * 2},0`;
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsx(ShapeFill, { d, color, fill, theme }),
    /* @__PURE__ */ jsx("path", { d, stroke: theme[color].solid, strokeWidth: sw, fill: "none" })
  ] });
});
export {
  SolidStyleEllipse
};
//# sourceMappingURL=SolidStyleEllipse.mjs.map
