import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import * as React from "react";
import { ShapeFill, useDefaultColorTheme } from "../../shared/ShapeFill.mjs";
const SolidStyleOval = React.memo(function SolidStyleOval2({
  w,
  h,
  strokeWidth: sw,
  fill,
  color
}) {
  const theme = useDefaultColorTheme();
  const d = getOvalIndicatorPath(w, h);
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsx(ShapeFill, { d, color, fill, theme }),
    /* @__PURE__ */ jsx("path", { d, stroke: theme[color].solid, strokeWidth: sw, fill: "none" })
  ] });
});
function getOvalIndicatorPath(w, h) {
  let d;
  if (h > w) {
    const offset = w / 2;
    d = `
    M0,${offset}
    a${offset},${offset},0,1,1,${offset * 2},0
    L${w},${h - offset}
    a${offset},${offset},0,1,1,-${offset * 2},0
    Z`;
  } else {
    const offset = h / 2;
    d = `
    M${offset},0
    L${w - offset},0
    a${offset},${offset},0,1,1,0,${offset * 2}
    L${offset},${h}
    a${offset},${offset},0,1,1,0,${-offset * 2}
    Z`;
  }
  return d;
}
export {
  SolidStyleOval,
  getOvalIndicatorPath
};
//# sourceMappingURL=SolidStyleOval.mjs.map
