import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import * as React from "react";
import { ShapeFill, useDefaultColorTheme } from "../../shared/ShapeFill.mjs";
const SolidStylePolygon = React.memo(function SolidStylePolygon2({
  outline,
  lines,
  fill,
  color,
  strokeWidth
}) {
  const theme = useDefaultColorTheme();
  let path = "M" + outline[0] + "L" + outline.slice(1) + "Z";
  if (lines) {
    for (const [A, B] of lines) {
      path += `M${A.x},${A.y}L${B.x},${B.y}`;
    }
  }
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsx(ShapeFill, { d: path, fill, color, theme }),
    /* @__PURE__ */ jsx("path", { d: path, stroke: theme[color].solid, strokeWidth, fill: "none" })
  ] });
});
export {
  SolidStylePolygon
};
//# sourceMappingURL=SolidStylePolygon.mjs.map
