import { Fragment, jsx, jsxs } from "react/jsx-runtime";
import { useEditor, useValue } from "@tldraw/editor";
import {
  ArrangeMenuSubmenu,
  ClipboardMenuGroup,
  ConversionsMenuGroup,
  ConvertToBookmarkMenuItem,
  ConvertToEmbedMenuItem,
  EditLinkMenuItem,
  FitFrameToContentMenuItem,
  GroupMenuItem,
  MoveToPageMenu,
  RemoveFrameMenuItem,
  ReorderMenuSubmenu,
  SelectAllMenuItem,
  ToggleAutoSizeMenuItem,
  ToggleLockMenuItem,
  UngroupMenuItem
} from "../menu-items.mjs";
import { TldrawUiMenuGroup } from "../primitives/menus/TldrawUiMenuGroup.mjs";
function DefaultContextMenuContent() {
  const editor = useEditor();
  const selectToolActive = useValue(
    "isSelectToolActive",
    () => editor.getCurrentToolId() === "select",
    [editor]
  );
  if (!selectToolActive)
    return null;
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsxs(TldrawUiMenuGroup, { id: "misc", children: [
      /* @__PURE__ */ jsx(GroupMenuItem, {}),
      /* @__PURE__ */ jsx(UngroupMenuItem, {}),
      /* @__PURE__ */ jsx(EditLinkMenuItem, {}),
      /* @__PURE__ */ jsx(ToggleAutoSizeMenuItem, {}),
      /* @__PURE__ */ jsx(RemoveFrameMenuItem, {}),
      /* @__PURE__ */ jsx(FitFrameToContentMenuItem, {}),
      /* @__PURE__ */ jsx(ConvertToEmbedMenuItem, {}),
      /* @__PURE__ */ jsx(ConvertToBookmarkMenuItem, {}),
      /* @__PURE__ */ jsx(ToggleLockMenuItem, {})
    ] }),
    /* @__PURE__ */ jsxs(TldrawUiMenuGroup, { id: "modify", children: [
      /* @__PURE__ */ jsx(ArrangeMenuSubmenu, {}),
      /* @__PURE__ */ jsx(ReorderMenuSubmenu, {}),
      /* @__PURE__ */ jsx(MoveToPageMenu, {})
    ] }),
    /* @__PURE__ */ jsx(ClipboardMenuGroup, {}),
    /* @__PURE__ */ jsx(ConversionsMenuGroup, {}),
    /* @__PURE__ */ jsx(TldrawUiMenuGroup, { id: "select-all", children: /* @__PURE__ */ jsx(SelectAllMenuItem, {}) })
  ] });
}
export {
  DefaultContextMenuContent
};
//# sourceMappingURL=DefaultContextMenuContent.mjs.map
