import { jsx } from "react/jsx-runtime";
import { useEditor } from "@tldraw/editor";
import classnames from "classnames";
import * as React from "react";
const TldrawUiButton = React.forwardRef(
  function TldrawUiButton2({ children, disabled, type, ...props }, ref) {
    const editor = useEditor();
    const current = ref?.current;
    if (disabled && current === document.activeElement) {
      editor.getContainer().focus();
    }
    return /* @__PURE__ */ jsx(
      "button",
      {
        ref,
        type: "button",
        draggable: false,
        disabled,
        ...props,
        className: classnames("tlui-button", `tlui-button__${type}`, props.className),
        children
      }
    );
  }
);
export {
  TldrawUiButton
};
//# sourceMappingURL=TldrawUiButton.mjs.map
